=begin 
(c) TIG 2009
Script: triangulateQuadFaces.rb
Usage:   Type triangulateQuadFaces in console
  or pick from Plugins Menu "Triangulate Quad Faces in Selection"
Result: it triangulates all selected quad faces but keeps UV mapping etc...
v1.0  First Release 20091115
=end
require 'sketchup.rb'
def triangulateQuadFaces()
    model=Sketchup.active_model
    ents=model.active_entities
    ss=model.selection
    qfaces=[]
    ss.each{|e|qfaces<<e if e.class==Sketchup::Face and e.vertices.length==4}
    if not qfaces[0]
      UI.messagebox("No Quad Faces in Selection.")
      return nil
    end#if
    model.start_operation("Triangulate Quad Faces")
    count=1
    qfaces.each{|face|
      msg="Triangulating Quad Face "+count.to_s+" of "+qfaces.length.to_s
      Sketchup::set_status_text(msg)
      ents=face.parent.entities
      e0=face.edges[0]
      mat=e0.material
      lay=e0.layer
      hid=e0.hidden?
      smo=e0.smooth?
      sof=e0.soft?
      edg=ents.add_line(face.vertices[0].position,face.vertices[2].position)
      edg.material=mat
      edg.layer=lay
      edg.hidden=hid
      edg.smooth=smo
      edg.soft=sof
      count+=1
    }
    ss.clear
    msg="Triangulate Quad Faces Done."
    Sketchup::set_status_text(msg)
    UI.messagebox(qfaces.length.to_s+" Quad Faces Triangulated.")
    model.commit_operation
end#def
###
if not file_loaded?(File.basename(__FILE__))
  UI.menu("Plugins").add_item("Triangulate Quad Faces in Selection"){triangulateQuadFaces()}
end#if
file_loaded(File.basename(__FILE__))
###
